diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index 5cba540b4..a6924d945 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -25,7 +25,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.function.Supplier;
 
-public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
+public class BlockLogicJarButterfly extends BlockLogic implements ISupportable, BlockLogic.MatcherEntityEquivalency<TileEntityJarButterfly> {
     public static final int MASK_HANGING = 0b0000_0001;
     public static final int MASK_ANGLED = 0b0000_0010;
     private final @NotNull Supplier<@NotNull Item> itemSupplier;
@@ -152,12 +152,14 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityJarButterfly thisJar) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityJarButterfly thatJar))
-            return false;
-        return thisJar.color.id() == thatJar.color.id();
+    public @NotNull Class<TileEntityJarButterfly> getEntityEquivalencyClass() {
+        return TileEntityJarButterfly.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @NotNull TileEntityJarButterfly thisButterfly, @NotNull TileEntityJarButterfly thatButterfly
+    ) {
+        return thisButterfly.color.id() == thatButterfly.color.id();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index b33ba3f0a..0f49116de 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -7,12 +7,17 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicJukebox extends BlockLogic {
+public class BlockLogicJukebox extends BlockLogic 
+implements
+    BlockLogic.MatcherDataEquivalency,
+    BlockLogic.MatcherEntityEquivalency<TileEntityJukebox>
+{
 	public BlockLogicJukebox(@NotNull Block<?> block) {
         super(block, Materials.WOOD);
         block.withEntity(TileEntityJukebox::new);
@@ -51,19 +56,36 @@ public class BlockLogicJukebox extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
+    public boolean isEquivalent(
+        @NotNull WorldSource world,
+        @NotNull TilePosc thisPos, @NotNull TilePosc thatPos,
+        @NotNull Block<?> thatBlock
+    ) {
+        if (!this.isEquivalentBlockForMatcher(thatBlock)) return false;
         final int thisData, thatData; {
             thisData = world.getBlockData(thisPos);
             thatData = world.getBlockData(thatPos);
         }
         if (thisData != thatData) return false;
-        if ((thisData | thatData) == 0) return true;
+        if (thatData == 0 /*&& thatData == 0*/) return true;
+        return this.isEquivalentEntityForMatcher(world, thisPos, thatPos);
+    }
 
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityJukebox thisJukebox) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityJukebox thatJukebox))
-            return false;
+    @Override
+    public boolean isEntityRequiredForMatching() {
+        return false;
+    }
+
+    @Override
+    public @NotNull Class<TileEntityJukebox> getEntityEquivalencyClass() {
+        return TileEntityJukebox.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @Nullable TileEntityJukebox thisJukebox, @Nullable TileEntityJukebox thatJukebox
+    ) {
+        if (thisJukebox == null || thatJukebox == null) return thisJukebox == null && thatJukebox == null;
         return thisJukebox.record == thatJukebox.record;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index 1c6969c32..2f8cbeef1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -22,11 +22,6 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
         super(block, Materials.WOOD);
     }
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return 0;
-    }
-
     @Override
     public boolean isSolidRender() {
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index 2fec961c1..1d17e7402 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -173,7 +173,7 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     }
 
     @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
+    protected boolean isEquivalentBlockForMatcher(@NotNull Block<?> other) {
         return other.getLogic() instanceof BlockLogicLamp lamp && this.isActive == lamp.isActive;
     }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index 30776c77a..f2d134527 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -14,7 +14,7 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public abstract class BlockLogicLayerBase extends BlockLogic
+public abstract class BlockLogicLayerBase extends BlockLogic implements BlockLogic.MatcherDataEquivalency
 {
     public final @Nullable Block<?> fullBlock;
     public static final int MASK_HEIGHT = 0b111;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 13b1d03e7..4c083affd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -18,7 +18,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable {
+public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable implements BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
     public BlockLogicLayerLeaves(@NotNull Block<? extends BlockLogicLayerLeaves> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
@@ -93,7 +93,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return super.getMatcherEquivalenceData(data) & ~MASK_PERMANENT;
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_PERMANENT;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index df0b4cd1a..fea1184e5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -201,9 +201,4 @@ public class BlockLogicLeavesBase extends BlockLogic {
     public float getAmbientOcclusionStrength(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return enableTreeShadowing ? 0.8f : 0.0f;
     }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return data & ~MASK_DECAY_DATA;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index 39f7684d8..e672a9731 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -21,7 +21,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBonemealable {
+public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBonemealable, BlockLogic.MatcherDataEquivalency.Masked {
 
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 4;
@@ -133,4 +133,9 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
     public static int setGrowthRate(int meta, int growthRate) {
         return (meta & ~MASK_GROWTH_DATA) | (growthRate << 4) & MASK_GROWTH_DATA;
     }
+
+    @Override
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_DECAY_DATA;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index fcd2d4395..430595cbf 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -17,7 +17,7 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry implements IBonemealable
+public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry implements IBonemealable, BlockLogic.MatcherDataEquivalency.Masked
 {
     public static final int MASK_GROWTH_DATA = 0b1111_0000;
     public static final int MAX_GROWTH_STATE = 1;
@@ -112,4 +112,9 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
     public static int setGrowthRate(int meta, int growthRate) {
         return (meta & ~MASK_GROWTH_DATA) | (growthRate << 4) & MASK_GROWTH_DATA;
     }
+
+    @Override
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_DECAY_DATA;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index e029e54be..a1c166143 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -16,14 +16,13 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicLever extends BlockLogic implements ISupportable {
+public class BlockLogicLever extends BlockLogic implements ISupportable, BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MASK_POWERED = 0b0001_0000;
     public static final int MASK_ROTATION = 0b0000_1111;
     public static final int ROTATION_EAST = 1;
@@ -40,8 +39,8 @@ public class BlockLogicLever extends BlockLogic implements ISupportable {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public int getMatcherDataEquivalencyMask() {
+        return MASK_POWERED;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index e1066c02f..13508dc26 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -11,6 +11,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
@@ -32,11 +33,6 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
         this.isActive = isActive;
     }
 
-    @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicMatcher matcher && (this.isActive == matcher.isActive);
-    }
-
     @Override
     public int tickDelay() {
         return 4;
@@ -113,40 +109,45 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     public void updateState(@NotNull World world, @NotNull TilePosc tilePos) {
-        Axis a = BlockLogicAxisAligned.metaToAxis(world.getBlockData(tilePos) & BlockLogicAxisAligned.MASK_DIRECTION);
+        final int meta = world.getBlockData(tilePos);
+        final Axis axis = BlockLogicAxisAligned.metaToAxis(meta & BlockLogicAxisAligned.MASK_DIRECTION);
 
-        TilePos front = new TilePos(tilePos);
-        TilePos back = new TilePos(tilePos);
-        switch (a) {
-            case X:
-                front.x += 1;
-                back.x -= 1;
-                break;
-            case Y:
-                front.y += 1;
-                back.y -= 1;
-                break;
-            case Z:
-            default:
-                front.z += 1;
-                back.z -= 1;
-                break;
+        final TilePos frontPos = new TilePos(tilePos);
+        final TilePos backPos = new TilePos(tilePos);
+        switch (axis) {
+            default -> { return; }
+            case X -> {
+                frontPos.x += 1;
+                backPos.x -= 1;
+            }
+            case Y -> {
+                frontPos.y += 1;
+                backPos.y -= 1;
+            }
+            case Z -> {
+                frontPos.z += 1;
+                backPos.z -= 1;
+            }
         }
 
+        final Block<?> front = world.getBlockType(frontPos);
+        final Block<?> back = world.getBlockType(backPos);
 
-        final @Nullable Block<?> frontBlock = world.getBlockType(front);
-        final boolean backMatchesFront = frontBlock.isEquivalent(world, front, back);
+        final boolean isUnionImpl =
+            (front == back) ||
+            front.getLogic().getClass() == back.getLogic().getClass();
+        
+        final boolean matches = (isUnionImpl)
+            ? front.isEquivalent(world, frontPos, backPos, back)
+            : front.isEquivalent(world, frontPos, backPos, back) && back.isEquivalent(world, backPos, frontPos, front);
 
-        if (!this.isActive && backMatchesFront) {
-            world.setBlockTypeDataNotify(tilePos, Blocks.MATCHER_ACTIVE, world.getBlockData(tilePos));
-        } else if (this.isActive && !backMatchesFront) {
-            world.setBlockTypeDataNotify(tilePos, Blocks.MATCHER, world.getBlockData(tilePos));
-        }
+        if (this.isActive == matches) return;
+        world.setBlockTypeDataNotify(tilePos, (matches) ? Blocks.MATCHER_ACTIVE : Blocks.MATCHER, meta);
     }
 
     @Override
     public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
-        if (!this.isActive) {return;}
+        if (!this.isActive) return;
         world.playBlockEvent(tilePos, LevelListener.EVENT_CONDUIT_SURFACE_PARTICLES, packEventConduitData(null, 10));
     }
 
@@ -168,4 +169,14 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
         return new ItemStack[]{new ItemStack(Blocks.MATCHER)};
     }
 
+    public static void updateNeighboringMatchers(
+        final @NotNull World world,
+        final @NotNull TilePosc origin
+    ) {
+        final var query = new TilePos();
+        for (final var dir : Direction.all) {
+            final var b = world.getBlockType(origin.add(dir, query));
+            if (b.getLogic() instanceof BlockLogicMatcher matcher) matcher.scheduleUpdate(world, query);
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
index db9199595..9cbe60533 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMeshGold.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
@@ -12,7 +11,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicMeshGold extends BlockLogicMesh {
+public class BlockLogicMeshGold extends BlockLogicMesh implements BlockLogic.MatcherEntityEquivalency<TileEntityMeshGold> {
     public BlockLogicMeshGold(@NotNull Block<?> block) {
         super(block);
         block.withEntity(TileEntityMeshGold::new);
@@ -44,15 +43,13 @@ public class BlockLogicMeshGold extends BlockLogicMesh {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        if (super.isEquivalent(world, thisPos, thatPos)) {
-            TileEntity thisEntity = world.getTileEntity(thisPos);
-            TileEntity otherEntity = world.getTileEntity(thatPos);
-            if (thisEntity instanceof TileEntityMeshGold thisMesh && otherEntity instanceof TileEntityMeshGold otherMesh) {
-                return stacksAreSame(thisMesh.filterItem, otherMesh.filterItem);
-            }
-        }
-        return false;
+    public @NotNull Class<TileEntityMeshGold> getEntityEquivalencyClass() {
+        return TileEntityMeshGold.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(@NotNull TileEntityMeshGold thisMesh, @NotNull TileEntityMeshGold thatMesh) {
+        return stacksAreSame(thisMesh.filterItem, thatMesh.filterItem);
     }
 
     public boolean stacksAreSame(@Nullable ItemStack a, @Nullable ItemStack b) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index 6f1777a07..464e5c4e3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -15,7 +15,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
+public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated implements BlockLogic.MatcherEntityEquivalency<TileEntityMobSpawner> {
 
     public BlockLogicMobSpawner(@NotNull Block<?> block) {
         super(block);
@@ -102,12 +102,14 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        if (!(world.getTileEntity(thisPos) instanceof TileEntityMobSpawner thisSpawner) ||
-            !(world.getTileEntity(thatPos) instanceof TileEntityMobSpawner thatSpawner))
-            return false;
+    public @NotNull Class<TileEntityMobSpawner> getEntityEquivalencyClass() {
+        return TileEntityMobSpawner.class;
+    }
+
+    @Override
+    public boolean isEquivalentEntityForMatcherImpl(
+        @NotNull TileEntityMobSpawner thisSpawner, @NotNull TileEntityMobSpawner thatSpawner
+    ) {
         final @Nullable String thisId, thatId; {
             thisId = thisSpawner.getMobId();
             thatId = thatSpawner.getMobId();
@@ -115,5 +117,5 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
         if (thisId == thatId) return true;
         if (thisId == null || thatId == null) return false;
         return thisId.equals(thatId);
-    }
+   }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index 83a4f2f06..b9e7533fa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -13,6 +13,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -20,27 +21,25 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
-public class BlockLogicNote extends BlockLogic {
+public class BlockLogicNote extends BlockLogic implements BlockLogic.MatcherDataEquivalency {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final int MASK_NOTE = 0b0011_1111;
     public static final int MASK_POWERED = 0b1000_0000;
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        assert world.getBlockType(thisPos) == this.block;
-        if (world.getBlockType(thatPos) != this.block) return false;
-        final int thisData, thatData; {
-            thisData = world.getBlockData(thisPos);
-            thatData = world.getBlockData(thatPos);
+    public boolean isEquivalent(
+        @NotNull WorldSource world,
+        @NotNull TilePosc thisPos, @NotNull TilePosc thatPos,
+        @NotNull Block<?> thatBlock
+    ) {
+        if (!this.isEquivalentBlockForMatcher(thatBlock)) return false;
+        if (!this.isEquivalentDataForMatcher(world, thisPos, thatPos)) return false;
+        final @NotNull Instrument thisInstrument, thatInstrument; {
+            final var query = new TilePos();
+            thisInstrument = Instrument.getInstrumentFromBlock(world.getBlockType(thisPos.down(query)));
+            thatInstrument = Instrument.getInstrumentFromBlock(world.getBlockType(thatPos.down(query)));
         }
-        if (thisData != thatData) return false; // We check note as well because it sucks otherwise
-        // // TODO instrument update
-        // final @NotNull Instrument thisInstru, thatInstru; {
-        //     final var query = new TilePos();
-        //     thisInstru = Instrument.getInstrumentFromBlock(world.getBlockType(thisPos.down(query)));
-        //     thatInstru = Instrument.getInstrumentFromBlock(world.getBlockType(thatPos.down(query)));
-        // }
-        // if (thisInstru != thatInstru) return false; // reference eq
+        if (thisInstrument != thatInstrument) return false; // reference eq
         return true;
     }
 
@@ -56,10 +55,12 @@ public class BlockLogicNote extends BlockLogic {
         final int data = world.getBlockData(tilePos);
         final boolean hasSignal = world.hasNeighborSignal(tilePos);
         final boolean isPowered = isPowered(data);
-        if (isPowered == hasSignal) return;
-        world.setBlockData(tilePos, data ^ MASK_POWERED);
-        if (hasSignal) triggerNote(world, tilePos);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block);
+        if (isPowered != hasSignal) {
+            world.setBlockData(tilePos, data ^ MASK_POWERED);
+            if (hasSignal) triggerNote(world, tilePos);
+            // world.notifyBlocksOfNeighborChange(tilePos, this.block);
+        }
+        BlockLogicMatcher.updateNeighboringMatchers(world, tilePos);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index abacf19c0..8380cd13d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -12,14 +12,13 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
 
 public class BlockLogicOverlayPebbles extends BlockLogic
-    implements ISupportable
+    implements ISupportable, BlockLogic.MatcherDataEquivalency
 {
     public static final int MAX_PEBBLES = 3;
     public static final int MASK_PEBBLE_AMOUNT = 0b0000_0011;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
index 60d30cd09..5df791596 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
@@ -12,7 +12,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicPlanksPainted extends BlockLogic implements IPainted
+public class BlockLogicPlanksPainted extends BlockLogic implements IPainted, BlockLogic.MatcherDataEquivalency
 {
     public BlockLogicPlanksPainted(@NotNull Block<?> block)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index f2af23610..6c3a6c0b6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -7,6 +7,8 @@ import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.animal.MobPig;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
@@ -26,7 +28,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicPortal extends BlockLogicTransparent implements IPainted {
+public class BlockLogicPortal extends BlockLogicTransparent implements IPainted, BlockLogic.MatcherDataEquivalency.Masked {
     public static final int MAX_PORTAL_SIZE = 32;
     public static final int MASK_COLOR = 0b1111_0000;
     public static final int MASK_ROTATION = 0b0000_0001;
@@ -41,8 +43,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     public final @NotNull Block<?> portalTrigger;
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_ROTATION;
+    public int getMatcherDataEquivalencyMask() {
+        return ~(MASK_ROTATION | MASK_SOURCE);
     }
 
     public BlockLogicPortal(@NotNull Block<?> block, @NotNull Dimension targetDimension, @NotNull Block<?> portalMaterial, @NotNull Block<?> portalTrigger) {
@@ -319,7 +321,11 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 }
             }
         }
-        if (entity.vehicle == null && entity.passenger == null) {
+        if (entity instanceof Player ridingPlayer && ridingPlayer.vehicle instanceof MobPig) {
+            ridingPlayer.handlePortal(this.block.id(), getColor(world, tilePos));
+        } else if (entity instanceof MobPig && entity.passenger instanceof Player riderPlayer) {
+            riderPlayer.handlePortal(this.block.id(), getColor(world, tilePos));
+        } else if (entity.vehicle == null && entity.passenger == null) {
             entity.handlePortal(this.block.id(), getColor(world, tilePos));
         }
     }
